function obj = addaxes(obj, items, parent)

    if nargin < 3 || isempty(parent)
        hparent = obj.Window;
    elseif iscell(parent)
        hparent = getfield(obj.Controls, parent{:});
    else
        hparent = obj.Controls.(parent);
    end

    for n = 1:numel(items)
        item = items{n};

        name = item{1};
        position = item{2};

        if numel(item) >= 3
            additional = item(3:end);
        else
            additional = {};
        end

        h = axes(...
            'Parent', hparent,...
            obj.defaultGlobalStyle{:},...
            obj.defaultAxesStyle{:},...
            'Position', position,...
            additional{:});

        if iscell(name)
            obj.Controls = setfield(obj.Controls, name{:}, h);
        elseif ~isempty(name)
            obj.Controls.(name) = h;
        end
    end
end
