function obj = addgroups(obj, items, parent)

    if nargin < 3 || isempty(parent)
        hparent = obj.Window;
    elseif iscell(parent)
        hparent = getfield(obj.Controls, parent{:});
    else
        hparent = obj.Controls.(parent);
    end

    for n = 1:numel(items)
        item = items{n};

        name = item{1};
        title = item{2};
        position = item{3};
        
        if numel(item) >= 4
            additional = item(4:end);
        else
            additional = {};
        end

        h = uibuttongroup(...
            'Parent', hparent, ...
            obj.defaultGlobalStyle{:}, ...
            obj.defaultPanelStyle{:}, ...
            'Title', title, ...
            'Position', position,...
            additional{:});

        if iscell(name)
            obj.Controls = setfield(obj.Controls, name{:}, h);
        elseif ~isempty(name)
            obj.Controls.(name) = h;
        end
    end
end
