function obj = addwindow(obj, varargin)
    if nargin == 2
        value = varargin{1};
    else
        value = varargin;
    end

    name = value{1};
    title = value{2};
    position = value{3};

    if numel(value) > 3
        additional = value(4:end);
    else
        additional = {};
    end

    if numel(position) == 2
        wpos = vertcat(0, 0, position(:));
    else
        wpos = position;
    end

    defaultBackground = get(0, 'defaultUicontrolBackgroundColor');

    h = figure( ...
        'Color', defaultBackground, ...
        obj.defaultGlobalStyle{:},...
        obj.defaultFigureStyle{:},...
        'MenuBar','none',...
        'Name', title,...
        'Position', wpos,...
        'Visible', 'off',...
        additional{:});

    if numel(position) == 2
        units = get(h, 'Units');
        set(h, 'Units', 'normalized');
        pos = get(h, 'Position' );
        pos(1:2) = 0.5 - pos(3:4)/2;
        set(h, 'Position', pos);
        set(h, 'Units', units);
    end

    obj.Window = h;
    obj.Controls.(name) = h;
end