classdef window < handle
    properties(Access=private)
        defaultEditHeight = 1.6923076923076;
        defaultTextHeight = 1.07692307692308;
        defaultGlobalStyle = {'Units', 'characters'};
        defaultFigureStyle = {'HandleVisibility', 'callback', 'NumberTitle', 'off', 'Resize', 'off'};
        defaultAxesStyle = {'HandleVisibility', 'callback', 'NextPlot', 'replacechildren', 'Box', 'on'};
        defaultPanelStyle = {'BorderType', 'line', 'Clipping', 'on', 'HighlightColor', [0, 0, 0]};
        defaultControlStyle = {'HorizontalAlignment', 'left'};
    end
    
    properties(SetAccess=private)
        Window = [];
        Controls = [];
    end

    methods
        function obj = window(varargin)
            obj = addwindow(obj, varargin{:});
        end
    end
    
    methods
        function cpos = vcenter(obj, pos)
            h = obj.defaultTextHeight;
            base = pos(2) + pos(4)/2 - h/2;
            cpos = horzcat(pos(1), base, pos(3), h);
        end
        
        function wait(obj)
            uiwait(obj.Window);
        end
        
        function resume(obj)
            uiresume(obj.Window);
        end
        
        function close(obj)
            close(obj.Window);
        end
    end
    
    methods
        obj = addaxes(obj, items, parent);
        obj = addgroups(obj, items, parent);
        obj = addpanels(obj, items, parent);
        obj = addcontrols(obj, items, parent);
    end
end
